/*
	Example for atmega 328P
	
 * nrf_test.c
 *
 * Created: 27.11.2016 19:17:38
 *  Author: Aleks (tc_art@mail.ru)
 */ 


#include <avr/io.h>
#define F_CPU 8000000UL
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include <util/delay.h>


#include "nrf/nrf.h"

#define SS  B,2 //ss piin nrf24l01p in atmega if no use in spi mode always output
#define SPI_SCK B,5 //sck piin nrf24l01p
#define SPI_MISO B,4 //miso piin nrf24l01p
#define SPI_MOSI B,3 //mosi piin nrf24l01p

uint8_t nrf_buf[32];
void spi_init()
// Initialize pins for spi communication
{
	SET(DDR,SPI_MOSI);
	SET(DDR,SPI_SCK);
	SET(DDR,SS);
	SET(PORT,SS);
	CLR(DDR,SPI_MISO);
	CLR(PORT,SPI_SCK);
	CLR(PORT,SPI_MOSI);
	SET(PORT,SPI_MISO);

	SPCR = ((1<<SPE)|               // SPI Enable
	(0<<SPIE)|              // SPI Interupt Enable
	(0<<DORD)|              // Data Order (0:MSB first / 1:LSB first)
	(1<<MSTR)|              // Master/Slave select
	(0<<SPR1)|(0<<SPR0)|    // SPI Clock Rate
	(0<<CPOL)|              // Clock Polarity (0:SCK low / 1:SCK hi when idle)
	(0<<CPHA));             // Clock Phase (0:leading / 1:trailing edge sampling)

	SPSR = (1<<SPI2X);              // Double Clock Rate
}

int main(void)
{
	cli();
	wdt_enable(WDTO_2S);
	
		spi_init();
		nrf_init();
		nrf_read_config();
		nrf_config.NRF_Adres_Length=5;
		nrf_config.NRF_Auto_Retransmit_Count=0x0f;
		nrf_config.NRF_Auto_Retransmit_Delay=0x01;
		nrf_config.NRF_Channel=2;
		nrf_config.NRF_CRC_Enable=1;
		nrf_config.NRF_CRC_Mode=1;
		nrf_config.NRF_Data_Rate=2;
		nrf_config.NRF_En_No_Ack=1;
		nrf_config.NRF_Enable_Pipe_0=1;
		nrf_config.NRF_Enable_Pipe_1=0;
		nrf_config.NRF_Enable_Pipe_2=0;
		nrf_config.NRF_Enable_Pipe_3=0;
		nrf_config.NRF_Enable_Pipe_4=0;
		nrf_config.NRF_Enable_Pipe_5=0;
		nrf_config.NRF_Mode_RX=1;
		nrf_config.NRF_Payload_Size_Pipe0=32;
		nrf_config.NRF_Payload_Size_Pipe1=32;
		nrf_config.NRF_Payload_Size_Pipe2=32;
		nrf_config.NRF_Payload_Size_Pipe3=32;
		nrf_config.NRF_Payload_Size_Pipe4=32;
		nrf_config.NRF_Payload_Size_Pipe5=32;
		nrf_config.NRF_Pipe_Auto_Ack_0=1;
		nrf_config.NRF_Pipe_Auto_Ack_1=0;
		nrf_config.NRF_Pipe_Auto_Ack_2=0;
		nrf_config.NRF_Pipe_Auto_Ack_3=0;
		nrf_config.NRF_Pipe_Auto_Ack_4=0;
		nrf_config.NRF_Pipe_Auto_Ack_5=0;
		nrf_config.NRF_RX_Adress_Pipe0[0]=0x07;
		nrf_config.NRF_RX_Adress_Pipe0[1]=0x07;
		nrf_config.NRF_RX_Adress_Pipe0[2]=0x07;
		nrf_config.NRF_RX_Adress_Pipe0[3]=0x07;
		nrf_config.NRF_RX_Adress_Pipe0[4]=0x07;
		nrf_config.NRF_RX_Adress_Pipe1[0]=0xc2;
		nrf_config.NRF_RX_Adress_Pipe1[1]=0xc2;
		nrf_config.NRF_RX_Adress_Pipe1[2]=0xc2;
		nrf_config.NRF_RX_Adress_Pipe1[3]=0xc2;
		nrf_config.NRF_RX_Adress_Pipe1[4]=0xc2;
		nrf_config.NRF_RX_Adress_Pipe2=0xc3;
		nrf_config.NRF_RX_Adress_Pipe3=0xc4;
		nrf_config.NRF_RX_Adress_Pipe4=0xc5;
		nrf_config.NRF_RX_Adress_Pipe5=0xc6;
		nrf_config.NRF_TX_Adress[0]=0x07;
		nrf_config.NRF_TX_Adress[1]=0x07;
		nrf_config.NRF_TX_Adress[2]=0x07;
		nrf_config.NRF_TX_Adress[3]=0x07;
		nrf_config.NRF_TX_Adress[4]=0x07;
		nrf_config.NRF_TX_Power=0x03;
		nrf_config.nrf_buf=&nrf_buf;
		nrf_configure();
		sei();
		nrf_config.cur_status=NRF24L01_SEND_OK;

    while(1)
    {
		wdt_reset();
		nrf_check();
		if ((nrf_config.cur_status&NRF24L01_SEND_OK)&&((nrf_config.cur_status&NRF24L01_TRANSMIT_P)==0))
		{
			nrf_send(nrf_buf,32,1);
		}
		if (nrf_config.cur_status&NRF24L01_RECV_PACKET)
		{
			//packet recieve
			nrf_config.cur_status&=~NRF24L01_RECV_PACKET; //clear flag
		}
    }
}